-- PERF_MOVIMENTO_CONTABILE
SELECT  GPM.ID_PROGRAMMA_MUSICALE,
	PM.NUMERO AS NUMERO_PM,
	GPM.ID_EVENTO,	
	VPQ.ID_TIPO_MODELLO AS TIPOLOGIA_MOVIMENTO,
	GPM.IMPORTO_DDA AS IMPORTO_MANUALE,
	PME.COD_VOCE_INCASSO AS CODICE_VOCE_INCASSO,	
	PM.PROG_PROTOC_PERMESSO AS NUMERO_PERMESSO,
	VPQ.IMPORTO AS TOTALE_DEM_LORDO_PM,
	VPQ.REVERSALE AS NUMERO_REVERSALE,
	PME.FLAG_GRUPPO_PRINCIPALE AS FLAG_GRUPPO_PRINCIPALE,
	Q.NUM_FATTURA AS NUMERO_FATTURA,
	VPQ.IMPORTO AS IMPORTO_DEM_TOTALE,
  	NVL(GPE.ATTESI,0) AS NUMERO_PM_PREVISTI,
        CASE WHEN GPM.COD_VOCE_INCASSO='2244' THEN (NVL(GPE.ATTESI,0) - NVL(GPE.GRUPPOPRINCIPALE,0)) ELSE 0 END AS NUMERO_PM_PREVISTI_SPALLA,  
	VPQ.DATA AS DATA_REVERSALE,
  	PM.DATA_RESTITUZIONE AS DATA_RIENTRO,
CASE WHEN Q.DATA>=PM.DATA_RESTITUZIONE THEN TO_CHAR(Q.DATA,'YYYYMM') ELSE TO_CHAR(PM.DATA_RESTITUZIONE,'YYYYMM') END AS CONTABILITA,
CASE  WHEN VPQ.ID_TIPO_MODELLO = 1 THEN '501'
      WHEN VPQ.ID_TIPO_MODELLO = 17 OR VPQ.ID_TIPO_MODELLO = 7 THEN '221'
      ELSE '501' END AS TIPO_DOCUMENTO_CONTABILE,
      VPQ.COD_RAGGRUPPAMENTO
FROM PROGRAMMA_MUSICALE PM 
JOIN PROGRAMMA_MUSICALE_EVENTO PME ON PME.ID_PROGRAMMA_MUSICALE = PM.ID_PROGRAMMA_MUSICALE
JOIN GESTIONE_PM GPM ON GPM.ID_PROGRAMMA_MUSICALE=PM.ID_PROGRAMMA_MUSICALE
JOIN SPEI_ADMIN.VIEW_PMO_DISTRIBUZIONE VPQ ON VPQ.ID_QUIETANZA = GPM.ID_QUIETANZA AND VPQ.ID_EVENTO = PME.ID_EVENTO AND VPQ.COD_VOCE_INCASSO = PME.COD_VOCE_INCASSO
JOIN QUIETANZA Q ON Q.ID_QUIETANZA = GPM.ID_QUIETANZA
LEFT JOIN GPM_EVENTO GPE ON GPE.ID_EVENTO=PME.ID_EVENTO AND PME.COD_VOCE_INCASSO = GPE.COD_VOCE_INCASSO
WHERE PM.STATO='V'
AND PM.DATA_158 IS NOT NULL
AND GPM.STATO=1
AND GPM.ID_QUIETANZA IS NOT NULL
AND TRUNC(GPM.DATA_158,'MONTH')=TO_DATE('2017-01','YYYY-MM');


-- PERF_EVENTI_PAGATI
SELECT VPQ.ID_EVENTO AS ID_EVENTO, 
VPQ.COD_VOCE_INCASSO AS VOCE_INCASSO,
(CASE VPQ.SEPRAG WHEN '1700000' THEN L.COD_SEPRAG ELSE VPQ.SEPRAG END ) AS SEPRAG ,
VPQ.REVERSALE AS NUMERO_REVERSALE,
VPQ.IMPORTO AS IMPORTO_DEM,
TO_CHAR(VPQ.DATA,'YYYYMM') AS CONTABILITA,
case  when VPQ.ID_TIPO_MODELLO = 1 then '501'
      WHEN VPQ.ID_TIPO_MODELLO = 17 OR VPQ.ID_TIPO_MODELLO = 7 THEN '221'
      Else '501' END as TIPO,
(SELECT Q.NUM_FATTURA FROM QUIETANZA Q WHERE Q.ID_QUIETANZA = VPQ.ID_QUIETANZA) AS NUM_FATTURA,
L.DENOMINAZIONE AS DENOMINAZIONE_LOCALE,
S.CODICE_BA AS	CODICE_BA_LOCALE,
CS.CODICE AS	CODICE_SPEI_LOCALE,
EV.DATA_INIZIO AS DATA_INIZIO_EVENTO,
EV.ORA_INIZIO AS ORA_INIZIO_EVENTO,
NVL(GPE.ATTESI,0) AS NUMERO_PM_ATTESI,
CASE WHEN GPE.COD_VOCE_INCASSO='2244' THEN (NVL(GPE.ATTESI,0) - NVL(GPE.GRUPPOPRINCIPALE,0)) ELSE 0 END AS NUMERO_PM_ATTESI_SPALLA,
VPQ.COD_RAGGRUPPAMENTO
FROM SPEI_ADMIN.VIEW_PMO_DISTRIBUZIONE VPQ
JOIN EVENTO EV ON EV.ID_EVENTO = VPQ.ID_EVENTO
JOIN CLASSE_EVENTO CE ON EV.ID_EVENTO = CE.ID_CLASSE_EVENTO
JOIN SPAZIO S ON S.ID_SPAZIO = CE.ID_SPAZIO
JOIN LOCALE L ON S.ID_LOCALE = L.ID_LOCALE
JOIN CODICE_SPEI CS ON CS.ID_SPAZIO = S.ID_SPAZIO
LEFT JOIN GPM_EVENTO GPE ON GPE.ID_EVENTO = EV.ID_EVENTO AND GPE.COD_VOCE_INCASSO = VPQ.COD_VOCE_INCASSO
where SEPRAG=CS.COD_SEPRAG  -- AGGIUNTA DA UAT
AND TRUNC(VPQ.DATA,'MONTH')=TO_DATE('2017-01','YYYY-MM');


-- PERF_PROGRAMMA_MUSICALE
SELECT PM.ID_PROGRAMMA_MUSICALE AS ID_PROGRAMMA_MUSICALE, 
		PM.NUMERO AS NUMERO_PROGRAMMA_MUSICALE, 
		PM.TIPO AS TIPO_PM, 
		PM.SUPPORTO_PM AS SUPPORTO_PM, 
		PM.SUPPORTO_PM AS FOGLIO, 
		PM.DATA_ASSEGNAZIONE AS DATA_ASSEGNAZIONE, 
		PM.DATA_RESTITUZIONE AS DATA_RESTITUZIONE, 
		PM.DATA_COMPILAZIONE AS DATA_COMPILAZIONE, 
		PM.STATO AS STATO_PM, 
		PM.DATA_ANNULLAMENTO AS DATA_ANNULLAMENTO, 
		PM.FOGLIO_SEGUE_DI AS FOGLIO_SEGUE_DI, 
		PM.FOGLIO_SEGUE_DI AS PM_RIFERIMENTO, 
		PM.CAUSA_ANNULLAMENTO AS CAUSA_ANNULLAMENTO, 
    NVL(( SELECT COUNT (1) FROM PM_QUADRO_D PQD WHERE PQD.ID_PROGRAMMA_MUSICALE=PM.ID_PROGRAMMA_MUSICALE),0) AS TOTALE_CEDOLE,
    NVL((
      SELECT 
        SUM(CASE
          WHEN INSTR (NVL (DURATA_ESECUZIONE, 0), ':') > 0
          THEN
             -- siamo nel caso in cui ci sono i due punti
             CASE
                WHEN DECODE (REPLACE (TRANSLATE (NVL (SUBSTR (DURATA_ESECUZIONE,1,INSTR (NVL (DURATA_ESECUZIONE, 0), ':') - 1),'0'),'1234567890','##########'),'#'),NULL, NVL (SUBSTR (DURATA_ESECUZIONE,1,INSTR (NVL (DURATA_ESECUZIONE, 0), ':') - 1),'0'),NULL) IS NOT NULL
                AND DECODE (REPLACE (TRANSLATE (NVL (SUBSTR (DURATA_ESECUZIONE,INSTR (NVL (DURATA_ESECUZIONE, 0),':')+ 1),0),'1234567890','##########'),'#'),NULL, NVL ( SUBSTR ( DURATA_ESECUZIONE, INSTR (NVL (DURATA_ESECUZIONE, 0),':')+ 1),0),NULL) IS NOT NULL
                THEN
                   TO_NUMBER (NVL (SUBSTR (DURATA_ESECUZIONE, 1, INSTR (NVL (DURATA_ESECUZIONE, 0), ':') - 1),'0')) * 60 + TO_NUMBER (NVL (SUBSTR (DURATA_ESECUZIONE,INSTR (NVL (DURATA_ESECUZIONE, 0), ':') + 1),'0'))
                ELSE
                   0
             END
          ELSE
             -- siamo nel caso in cui non ci sono i due punti
             CASE
                WHEN DECODE ( REPLACE (TRANSLATE (DURATA_ESECUZIONE,'1234567890','##########'),'#'),NULL, DURATA_ESECUZIONE, NULL) IS NOT NULL
                THEN
                   TO_NUMBER (DURATA_ESECUZIONE)
                ELSE
                   0
             END
      END)
      FROM PM_QUADRO_D PQD WHERE PQD.ID_PROGRAMMA_MUSICALE=PM.ID_PROGRAMMA_MUSICALE
      ),0) AS TOTALE_DURATA_CEDOLE,
    ( SELECT COUNT (1) FROM PROGRAMMA_MUSICALE_EVENTO PME WHERE PME.ID_PROGRAMMA_MUSICALE = PM.ID_PROGRAMMA_MUSICALE ) AS GIORNATE_TRATTENIMENTO,
    ( SELECT decode(PME.FLAG_GRUPPO_PRINCIPALE,null,0,PME.FLAG_GRUPPO_PRINCIPALE)  FROM PROGRAMMA_MUSICALE_EVENTO PME WHERE PME.ID_PROGRAMMA_MUSICALE = PM.ID_PROGRAMMA_MUSICALE ) AS FLAG_GRUPPO_PRINCIPALE
	FROM PROGRAMMA_MUSICALE PM 
	WHERE 
  PM.STATO='V' 
		AND 
    TRUNC(PM.DATA_158,'MONTH') = TO_DATE('2017-01','YYYY-MM');
